searchNodes=[{"doc":"LcdDisplay is a simple Elixir library that allows you to control an Liquid-crystal display (LCD) like Hitachi HD44780.ExamplesAs an example, if you want to control a Hitachi HD44780 type display through I²C, you can use LcdDisplay.HD44780.I2C module as a display driver.# Start the LCD driver and get the initial display state. pid = LcdDisplay.start_display(LcdDisplay.HD44780.I2C, %{display_name: &quot;Display 1&quot;}) # Run a command. LcdDisplay.execute(pid, {:print, &quot;Hello world&quot;}) LcdDisplay.execute(pid, :clear)","ref":"LcdDisplay.html","title":"LcdDisplay","type":"module"},{"doc":"Executes a supported command that is specified.","ref":"LcdDisplay.html#execute/2","title":"LcdDisplay.execute/2","type":"function"},{"doc":"Finds or starts a supervised display controller process.","ref":"LcdDisplay.html#start_display/2","title":"LcdDisplay.start_display/2","type":"function"},{"doc":"Wraps a given display driver and controls the display using that driver.","ref":"LcdDisplay.DisplayController.html","title":"LcdDisplay.DisplayController","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"LcdDisplay.DisplayController.html#child_spec/1","title":"LcdDisplay.DisplayController.child_spec/1","type":"function"},{"doc":"Delegates the specified operation to the display driver, and updates the state as needed.ExamplesDisplayController.execute(pid, {:print, &quot;Hello&quot;})","ref":"LcdDisplay.DisplayController.html#execute/2","title":"LcdDisplay.DisplayController.execute/2","type":"function"},{"doc":"Starts a display driver process and registers the process with a composite key of driver module and display name.","ref":"LcdDisplay.DisplayController.html#start_link/1","title":"LcdDisplay.DisplayController.start_link/1","type":"function"},{"doc":"Discovers a process by the composite key of driver module atom and display name.","ref":"LcdDisplay.DisplayController.html#whereis/1","title":"LcdDisplay.DisplayController.whereis/1","type":"function"},{"doc":"Supervises display controller processes.","ref":"LcdDisplay.DisplaySupervisor.html","title":"LcdDisplay.DisplaySupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"LcdDisplay.DisplaySupervisor.html#child_spec/1","title":"LcdDisplay.DisplaySupervisor.child_spec/1","type":"function"},{"doc":"Creates a LcdDisplay.DisplayController process.Examplespid = DisplaySupervisor.display_controller( LcdDisplay.HD44780.I2C, %{ display_name: &quot;display 1&quot;, # the identifier i2c_bus: &quot;i2c-1&quot;, # I2C bus name i2c_address: 0x27, # 7-bit address rows: 2, # the number of display rows cols: 16, # the number of display columns font_size: &quot;5x8&quot; # &quot;5x10&quot; or &quot;5x8&quot; } )","ref":"LcdDisplay.DisplaySupervisor.html#display_controller/2","title":"LcdDisplay.DisplaySupervisor.display_controller/2","type":"function"},{"doc":"","ref":"LcdDisplay.DisplaySupervisor.html#start_link/1","title":"LcdDisplay.DisplaySupervisor.start_link/1","type":"function"},{"doc":"Defines a behaviour required for an LCD driver.","ref":"LcdDisplay.Driver.html","title":"LcdDisplay.Driver","type":"behaviour"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.Driver.html#c:execute/2","title":"LcdDisplay.Driver.execute/2","type":"callback"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.Driver.html#c:start/1","title":"LcdDisplay.Driver.start/1","type":"callback"},{"doc":"Type that represents a supported display command.Supported CommandDescription:clearClear the display.:homeMove the cursor home.:printPrint a text at the current cursor.:set_cursorSet the cursor position (row and column).:cursorSwitch on/off the underline cursor.:displaySwitch on/off the display without losing what is on it.:blinkSwitch on/off the block cursor.:autoscrollMake existing text shift when new text is printed.:backlightSwitch on/off the backlight.:text_directionMake text flow left/right from the cursor.:scrollScroll text left and right.:leftMove the cursor left.:rightMove the cursor right.:charProgram custom character to CGRAM.","ref":"LcdDisplay.Driver.html#t:command/0","title":"LcdDisplay.Driver.command/0","type":"type"},{"doc":"","ref":"LcdDisplay.Driver.html#t:config/0","title":"LcdDisplay.Driver.config/0","type":"type"},{"doc":"Type that represents an available display feature.","ref":"LcdDisplay.Driver.html#t:feature/0","title":"LcdDisplay.Driver.feature/0","type":"type"},{"doc":"Type that represents the display state.","ref":"LcdDisplay.Driver.html#t:t/0","title":"LcdDisplay.Driver.t/0","type":"type"},{"doc":"A collection of utility functions that are used for display drivers.","ref":"LcdDisplay.DriverUtil.html","title":"LcdDisplay.DriverUtil","type":"module"},{"doc":"Determines a cursor position based on the display configuration (rows and columns) and the zero-indexed cursor position (row and column).Examplesiex&gt; LcdDisplay.DriverUtil.determine_cursor_position({2, 16}, {0,0}) 0 iex&gt; LcdDisplay.DriverUtil.determine_cursor_position({2, 16}, {0,15}) 15 iex&gt; LcdDisplay.DriverUtil.determine_cursor_position({2, 16}, {1,0}) 64 iex&gt; LcdDisplay.DriverUtil.determine_cursor_position({2, 16}, {1,15}) 79","ref":"LcdDisplay.DriverUtil.html#determine_cursor_position/2","title":"LcdDisplay.DriverUtil.determine_cursor_position/2","type":"function"},{"doc":"Determine a list of row offsets based on how many columns the display has.Examplesiex&gt; LcdDisplay.DriverUtil.row_offsets_for_num_cols(8) {0, 64, 8, 72}iex&gt; LcdDisplay.DriverUtil.row_offsets_for_num_cols(16) {0, 64, 16, 80}iex&gt; LcdDisplay.DriverUtil.row_offsets_for_num_cols(20) {0, 64, 20, 84}","ref":"LcdDisplay.DriverUtil.html#row_offsets_for_num_cols/1","title":"LcdDisplay.DriverUtil.row_offsets_for_num_cols/1","type":"function"},{"doc":"Lets you control GPIOs. A thin wrapper of elixir-circuits/circuits_gpio.","ref":"LcdDisplay.GPIO.html","title":"LcdDisplay.GPIO","type":"module"},{"doc":"Callback implementation for LcdDisplay.GPIO.Behaviour.open/2.","ref":"LcdDisplay.GPIO.html#open/2","title":"LcdDisplay.GPIO.open/2","type":"function"},{"doc":"Callback implementation for LcdDisplay.GPIO.Behaviour.write/2.","ref":"LcdDisplay.GPIO.html#write/2","title":"LcdDisplay.GPIO.write/2","type":"function"},{"doc":"Defines a behaviour required for GPIO abstraction.","ref":"LcdDisplay.GPIO.Behaviour.html","title":"LcdDisplay.GPIO.Behaviour","type":"behaviour"},{"doc":"","ref":"LcdDisplay.GPIO.Behaviour.html#c:open/2","title":"LcdDisplay.GPIO.Behaviour.open/2","type":"callback"},{"doc":"","ref":"LcdDisplay.GPIO.Behaviour.html#c:write/2","title":"LcdDisplay.GPIO.Behaviour.write/2","type":"callback"},{"doc":"","ref":"LcdDisplay.GPIO.Behaviour.html#t:gpio_pin/0","title":"LcdDisplay.GPIO.Behaviour.gpio_pin/0","type":"type"},{"doc":"Knows how to commuticate with HD44780 type display via GPIO pins. Supports the 4-bit mode only. You can turn on/off one backlight LED.Examplesalias LcdDisplay.HD44780 config = %{ display_name: &quot;display 1&quot;, pin_rs: 2, pin_rw: 3, pin_en: 4, pin_d4: 23, pin_d5: 24, pin_d6: 25, pin_d7: 26, pin_led: 12, } # Start the LCD driver and get the initial display state. {:ok, display} = HD44780.GPIO.start(config) # Run a command and the display state will be updated. {:ok, display} = HD44780.GPIO.execute(display, {:print, &quot;Hello world&quot;})","ref":"LcdDisplay.HD44780.GPIO.html","title":"LcdDisplay.HD44780.GPIO","type":"module"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.HD44780.GPIO.html#execute/2","title":"LcdDisplay.HD44780.GPIO.execute/2","type":"function"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.HD44780.GPIO.html#start/1","title":"LcdDisplay.HD44780.GPIO.start/1","type":"function"},{"doc":"The configuration options.","ref":"LcdDisplay.HD44780.GPIO.html#t:config/0","title":"LcdDisplay.HD44780.GPIO.config/0","type":"type"},{"doc":"Knows how to commuticate with HD44780 type display via I2C. You can turn on/off one backlight LED.Examplesalias LcdDisplay.HD44780 config = %{ display_name: &quot;display 1&quot;, # the identifier i2c_bus: &quot;i2c-1&quot;, # I2C bus name i2c_address: 0x27, # 7-bit address rows: 2, # the number of display rows cols: 16, # the number of display columns font_size: &quot;5x8&quot; # &quot;5x10&quot; or &quot;5x8&quot; } # Start the LCD driver and get the initial display state. {:ok, display} = HD44780.I2C.start(config) # Run a command and the display state will be updated. {:ok, display} = HD44780.I2C.execute(display, {:print, &quot;Hello world&quot;})","ref":"LcdDisplay.HD44780.I2C.html","title":"LcdDisplay.HD44780.I2C","type":"module"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.HD44780.I2C.html#execute/2","title":"LcdDisplay.HD44780.I2C.execute/2","type":"function"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.HD44780.I2C.html#start/1","title":"LcdDisplay.HD44780.I2C.start/1","type":"function"},{"doc":"The configuration options.","ref":"LcdDisplay.HD44780.I2C.html#t:config/0","title":"LcdDisplay.HD44780.I2C.config/0","type":"type"},{"doc":"Lets you communicate with hardware devices using the I2C protocol. A thin wrapper of elixir-circuits/circuits_i2c.","ref":"LcdDisplay.I2C.html","title":"LcdDisplay.I2C","type":"module"},{"doc":"Callback implementation for LcdDisplay.I2C.Behaviour.open/1.","ref":"LcdDisplay.I2C.html#open/1","title":"LcdDisplay.I2C.open/1","type":"function"},{"doc":"Callback implementation for LcdDisplay.I2C.Behaviour.write/3.","ref":"LcdDisplay.I2C.html#write/3","title":"LcdDisplay.I2C.write/3","type":"function"},{"doc":"Defines a behaviour required for I²C abstraction.","ref":"LcdDisplay.I2C.Behaviour.html","title":"LcdDisplay.I2C.Behaviour","type":"behaviour"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#c:open/1","title":"LcdDisplay.I2C.Behaviour.open/1","type":"callback"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#c:write/3","title":"LcdDisplay.I2C.Behaviour.write/3","type":"callback"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#t:data/0","title":"LcdDisplay.I2C.Behaviour.data/0","type":"type"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#t:i2c_address/0","title":"LcdDisplay.I2C.Behaviour.i2c_address/0","type":"type"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#t:i2c_bus/0","title":"LcdDisplay.I2C.Behaviour.i2c_bus/0","type":"type"},{"doc":"Manages processes.","ref":"LcdDisplay.ProcessRegistry.html","title":"LcdDisplay.ProcessRegistry","type":"module"},{"doc":"","ref":"LcdDisplay.ProcessRegistry.html#child_spec/1","title":"LcdDisplay.ProcessRegistry.child_spec/1","type":"function"},{"doc":"Starts a unique registry.","ref":"LcdDisplay.ProcessRegistry.html#start_link/0","title":"LcdDisplay.ProcessRegistry.start_link/0","type":"function"},{"doc":"Returns a standardized via-tuple for this registry.Examplesiex&gt; ProcessRegistry.via_tuple(SomeKey) {:via, Registry, {ProcessRegistry, SomeKey}}","ref":"LcdDisplay.ProcessRegistry.html#via_tuple/1","title":"LcdDisplay.ProcessRegistry.via_tuple/1","type":"function"},{"doc":"Returns a PID or :undefined.","ref":"LcdDisplay.ProcessRegistry.html#whereis_name/1","title":"LcdDisplay.ProcessRegistry.whereis_name/1","type":"function"},{"doc":"LcdDisplay LcdDisplay allows you to control a Liquid-crystal display (LCD) like Hitachi HD44780 from Elixir.Here is the documentation and example apps for this library.For more info on the display, please refer to Hitachi HD44780 datasheet.","ref":"readme.html","title":"LcdDisplay","type":"extras"},{"doc":"You can install LcdDisplay by adding lcd_display to your list of dependencies in mix.exs:def deps do [ {:lcd_display, &quot;0.0.14&quot;} ] end","ref":"readme.html#installation","title":"LcdDisplay - Installation","type":"extras"},{"doc":"As an example, if you want to control a Hitachi HD44780 type display through I2C, you can use LcdDisplay.HD44780.I2C module as a display driver.Detectconnected devicesBefore connecting to an I2C device, please detect connected devices.iex&gt; Circuits.I2C.detect_devices() Circuits.I2C.detect_devices Devices on I2C bus &quot;i2c-1&quot;: * 64 (0x40) * 112 (0x70) 2 devices detected on 1 I2C busesStart an LCD driver and get a PID.driver_module = LcdDisplay.HD44780.I2C driver_config = %{ display_name: &quot;display 1&quot;, # the identifier i2c_bus: &quot;i2c-1&quot;, # I2C bus name i2c_address: 0x27, # 7-bit address rows: 2, # the number of display rows cols: 16, # the number of display columns font_size: &quot;5x8&quot; # &quot;5x10&quot; or &quot;5x8&quot; } pid = LcdDisplay.start_display(driver_module, driver_config)Run commandsPlease refer to the LcdDisplay.Driver documentation for supported display commands.LcdDisplay.execute(pid, {:print, &quot;Hello world&quot;}) LcdDisplay.execute(pid, :clear)","ref":"readme.html#usage","title":"LcdDisplay - Usage","type":"extras"},{"doc":"ExLCD for inspiration","ref":"readme.html#thanks","title":"LcdDisplay - Thanks","type":"extras"},{"doc":"Hitachi HD44780 datasheet","ref":"readme.html#links","title":"LcdDisplay - Links","type":"extras"}]